/* minefield.c generated by valac 0.42.3, the Vala compiler
 * generated from minefield.vala, do not modify */

/*
 * Copyright (C) 2011-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define TYPE_FLAG_TYPE (flag_type_get_type ())

#define TYPE_LOCATION (location_get_type ())
#define LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOCATION, Location))
#define LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOCATION, LocationClass))
#define IS_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOCATION))
#define IS_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOCATION))
#define LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOCATION, LocationClass))

typedef struct _Location Location;
typedef struct _LocationClass LocationClass;
typedef struct _LocationPrivate LocationPrivate;
enum  {
	LOCATION_0_PROPERTY,
	LOCATION_NUM_PROPERTIES
};
static GParamSpec* location_properties[LOCATION_NUM_PROPERTIES];

#define TYPE_NEIGHBOUR (neighbour_get_type ())
typedef struct _Neighbour Neighbour;

#define TYPE_MINEFIELD (minefield_get_type ())
#define MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MINEFIELD, Minefield))
#define MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MINEFIELD, MinefieldClass))
#define IS_MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MINEFIELD))
#define IS_MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MINEFIELD))
#define MINEFIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MINEFIELD, MinefieldClass))

typedef struct _Minefield Minefield;
typedef struct _MinefieldClass MinefieldClass;
typedef struct _MinefieldPrivate MinefieldPrivate;
enum  {
	MINEFIELD_0_PROPERTY,
	MINEFIELD_N_CLEARED_PROPERTY,
	MINEFIELD_IS_COMPLETE_PROPERTY,
	MINEFIELD_N_FLAGS_PROPERTY,
	MINEFIELD_USE_AUTOFLAG_PROPERTY,
	MINEFIELD_ELAPSED_PROPERTY,
	MINEFIELD_PAUSED_PROPERTY,
	MINEFIELD_NUM_PROPERTIES
};
static GParamSpec* minefield_properties[MINEFIELD_NUM_PROPERTIES];
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MINEFIELD_CLOCK_STARTED_SIGNAL,
	MINEFIELD_PAUSED_CHANGED_SIGNAL,
	MINEFIELD_TICK_SIGNAL,
	MINEFIELD_REDRAW_SECTOR_SIGNAL,
	MINEFIELD_MARKS_CHANGED_SIGNAL,
	MINEFIELD_EXPLODE_SIGNAL,
	MINEFIELD_CLEARED_SIGNAL,
	MINEFIELD_NUM_SIGNALS
};
static guint minefield_signals[MINEFIELD_NUM_SIGNALS] = {0};

typedef enum  {
	FLAG_TYPE_NONE,
	FLAG_TYPE_FLAG,
	FLAG_TYPE_MAYBE
} FlagType;

struct _Location {
	GObject parent_instance;
	LocationPrivate * priv;
	gboolean has_mine;
	gboolean cleared;
	FlagType flag;
	gint adjacent_mines;
};

struct _LocationClass {
	GObjectClass parent_class;
};

struct _Neighbour {
	gint x;
	gint y;
};

struct _Minefield {
	GObject parent_instance;
	MinefieldPrivate * priv;
	guint width;
	guint height;
	guint n_mines;
	Location** locations;
	gint locations_length1;
	gint locations_length2;
	gboolean exploded;
	gboolean placed_mines;
	gboolean _use_autoflag;
};

struct _MinefieldClass {
	GObjectClass parent_class;
};

struct _MinefieldPrivate {
	guint _n_cleared;
	guint _n_flags;
	gdouble clock_elapsed;
	GTimer* clock;
	guint clock_timeout;
	gboolean _paused;
};


static gpointer location_parent_class = NULL;
static gint Minefield_private_offset;
static gpointer minefield_parent_class = NULL;

GType flag_type_get_type (void) G_GNUC_CONST;
GType location_get_type (void) G_GNUC_CONST;
Location* location_new (void);
Location* location_construct (GType object_type);
static void location_finalize (GObject * obj);
GType neighbour_get_type (void) G_GNUC_CONST;
Neighbour* neighbour_dup (const Neighbour* self);
void neighbour_free (Neighbour* self);
GType minefield_get_type (void) G_GNUC_CONST;
Minefield* minefield_new (guint width,
                          guint height,
                          guint n_mines);
Minefield* minefield_construct (GType object_type,
                                guint width,
                                guint height,
                                guint n_mines);
gboolean minefield_is_clock_started (Minefield* self);
gdouble minefield_get_elapsed (Minefield* self);
gboolean minefield_has_mine (Minefield* self,
                             guint x,
                             guint y);
gboolean minefield_is_cleared (Minefield* self,
                               guint x,
                               guint y);
gboolean minefield_is_location (Minefield* self,
                                gint x,
                                gint y);
void minefield_multi_release (Minefield* self,
                              guint x,
                              guint y);
FlagType minefield_get_flag (Minefield* self,
                             guint x,
                             guint y);
guint minefield_get_n_adjacent_mines (Minefield* self,
                                      guint x,
                                      guint y);
gboolean minefield_get_use_autoflag (Minefield* self);
void minefield_clear_mine (Minefield* self,
                           guint x,
                           guint y);
void minefield_set_flag (Minefield* self,
                         guint x,
                         guint y,
                         FlagType flag);
static void minefield_place_mines (Minefield* self,
                            guint x,
                            guint y);
static void minefield_start_clock (Minefield* self);
static void minefield_clear_mines_recursive (Minefield* self,
                                      guint x,
                                      guint y);
static void minefield_stop_clock (Minefield* self);
gboolean minefield_get_is_complete (Minefield* self);
guint minefield_get_n_cleared (Minefield* self);
void minefield_set_n_cleared (Minefield* self,
                              guint value);
guint minefield_get_n_flags (Minefield* self);
void minefield_set_n_flags (Minefield* self,
                            guint value);
gboolean minefield_has_flag_warning (Minefield* self,
                                     guint x,
                                     guint y);
static void minefield_start_timer (Minefield* self);
static gboolean minefield_timeout_cb (Minefield* self);
static gboolean _minefield_timeout_cb_gsource_func (gpointer self);
static void minefield_continue_clock (Minefield* self);
void minefield_set_use_autoflag (Minefield* self,
                                 gboolean value);
gboolean minefield_get_paused (Minefield* self);
void minefield_set_paused (Minefield* self,
                           gboolean value);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void minefield_finalize (GObject * obj);
static void _vala_minefield_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_minefield_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

const Neighbour neighbour_map[8] = {{-1, 1}, {0, 1}, {1, 1}, {1, 0}, {1, -1}, {0, -1}, {-1, -1}, {-1, 0}};

GType
flag_type_get_type (void)
{
	static volatile gsize flag_type_type_id__volatile = 0;
	if (g_once_init_enter (&flag_type_type_id__volatile)) {
		static const GEnumValue values[] = {{FLAG_TYPE_NONE, "FLAG_TYPE_NONE", "none"}, {FLAG_TYPE_FLAG, "FLAG_TYPE_FLAG", "flag"}, {FLAG_TYPE_MAYBE, "FLAG_TYPE_MAYBE", "maybe"}, {0, NULL, NULL}};
		GType flag_type_type_id;
		flag_type_type_id = g_enum_register_static ("FlagType", values);
		g_once_init_leave (&flag_type_type_id__volatile, flag_type_type_id);
	}
	return flag_type_type_id__volatile;
}


Location*
location_construct (GType object_type)
{
	Location * self = NULL;
#line 18 "../src/minefield.vala"
	self = (Location*) g_object_new (object_type, NULL);
#line 18 "../src/minefield.vala"
	return self;
#line 252 "minefield.c"
}


Location*
location_new (void)
{
#line 18 "../src/minefield.vala"
	return location_construct (TYPE_LOCATION);
#line 261 "minefield.c"
}


static void
location_class_init (LocationClass * klass)
{
#line 18 "../src/minefield.vala"
	location_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/minefield.vala"
	G_OBJECT_CLASS (klass)->finalize = location_finalize;
#line 272 "minefield.c"
}


static void
location_instance_init (Location * self)
{
#line 21 "../src/minefield.vala"
	self->has_mine = FALSE;
#line 24 "../src/minefield.vala"
	self->cleared = FALSE;
#line 27 "../src/minefield.vala"
	self->flag = FLAG_TYPE_NONE;
#line 30 "../src/minefield.vala"
	self->adjacent_mines = 0;
#line 287 "minefield.c"
}


static void
location_finalize (GObject * obj)
{
	Location * self;
#line 18 "../src/minefield.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOCATION, Location);
#line 18 "../src/minefield.vala"
	G_OBJECT_CLASS (location_parent_class)->finalize (obj);
#line 299 "minefield.c"
}


GType
location_get_type (void)
{
	static volatile gsize location_type_id__volatile = 0;
	if (g_once_init_enter (&location_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LocationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) location_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Location), 0, (GInstanceInitFunc) location_instance_init, NULL };
		GType location_type_id;
		location_type_id = g_type_register_static (G_TYPE_OBJECT, "Location", &g_define_type_info, 0);
		g_once_init_leave (&location_type_id__volatile, location_type_id);
	}
	return location_type_id__volatile;
}


Neighbour*
neighbour_dup (const Neighbour* self)
{
	Neighbour* dup;
#line 34 "../src/minefield.vala"
	dup = g_new0 (Neighbour, 1);
#line 34 "../src/minefield.vala"
	memcpy (dup, self, sizeof (Neighbour));
#line 34 "../src/minefield.vala"
	return dup;
#line 327 "minefield.c"
}


void
neighbour_free (Neighbour* self)
{
#line 34 "../src/minefield.vala"
	g_free (self);
#line 336 "minefield.c"
}


GType
neighbour_get_type (void)
{
	static volatile gsize neighbour_type_id__volatile = 0;
	if (g_once_init_enter (&neighbour_type_id__volatile)) {
		GType neighbour_type_id;
		neighbour_type_id = g_boxed_type_register_static ("Neighbour", (GBoxedCopyFunc) neighbour_dup, (GBoxedFreeFunc) neighbour_free);
		g_once_init_leave (&neighbour_type_id__volatile, neighbour_type_id);
	}
	return neighbour_type_id__volatile;
}


static inline gpointer
minefield_get_instance_private (Minefield* self)
{
	return G_STRUCT_MEMBER_P (self, Minefield_private_offset);
}


Minefield*
minefield_construct (GType object_type,
                     guint width,
                     guint height,
                     guint n_mines)
{
	Minefield * self = NULL;
	Location** _tmp0_;
#line 140 "../src/minefield.vala"
	self = (Minefield*) g_object_new (object_type, NULL);
#line 142 "../src/minefield.vala"
	_tmp0_ = g_new0 (Location*, (width * height) + 1);
#line 142 "../src/minefield.vala"
	self->locations = (_vala_array_free (self->locations, self->locations_length1 * self->locations_length2, (GDestroyNotify) g_object_unref), NULL);
#line 142 "../src/minefield.vala"
	self->locations = _tmp0_;
#line 142 "../src/minefield.vala"
	self->locations_length1 = width;
#line 142 "../src/minefield.vala"
	self->locations_length2 = height;
#line 380 "minefield.c"
	{
		gint x = 0;
#line 143 "../src/minefield.vala"
		x = 0;
#line 385 "minefield.c"
		{
			gboolean _tmp1_ = FALSE;
#line 143 "../src/minefield.vala"
			_tmp1_ = TRUE;
#line 143 "../src/minefield.vala"
			while (TRUE) {
#line 392 "minefield.c"
				gint _tmp3_;
#line 143 "../src/minefield.vala"
				if (!_tmp1_) {
#line 396 "minefield.c"
					gint _tmp2_;
#line 143 "../src/minefield.vala"
					_tmp2_ = x;
#line 143 "../src/minefield.vala"
					x = _tmp2_ + 1;
#line 402 "minefield.c"
				}
#line 143 "../src/minefield.vala"
				_tmp1_ = FALSE;
#line 143 "../src/minefield.vala"
				_tmp3_ = x;
#line 143 "../src/minefield.vala"
				if (!(((guint) _tmp3_) < width)) {
#line 143 "../src/minefield.vala"
					break;
#line 412 "minefield.c"
				}
				{
					gint y = 0;
#line 144 "../src/minefield.vala"
					y = 0;
#line 418 "minefield.c"
					{
						gboolean _tmp4_ = FALSE;
#line 144 "../src/minefield.vala"
						_tmp4_ = TRUE;
#line 144 "../src/minefield.vala"
						while (TRUE) {
#line 425 "minefield.c"
							gint _tmp6_;
							Location** _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
							gint _tmp9_;
							Location* _tmp10_;
							Location* _tmp11_;
#line 144 "../src/minefield.vala"
							if (!_tmp4_) {
#line 436 "minefield.c"
								gint _tmp5_;
#line 144 "../src/minefield.vala"
								_tmp5_ = y;
#line 144 "../src/minefield.vala"
								y = _tmp5_ + 1;
#line 442 "minefield.c"
							}
#line 144 "../src/minefield.vala"
							_tmp4_ = FALSE;
#line 144 "../src/minefield.vala"
							_tmp6_ = y;
#line 144 "../src/minefield.vala"
							if (!(((guint) _tmp6_) < height)) {
#line 144 "../src/minefield.vala"
								break;
#line 452 "minefield.c"
							}
#line 145 "../src/minefield.vala"
							_tmp7_ = self->locations;
#line 145 "../src/minefield.vala"
							_tmp7__length1 = self->locations_length1;
#line 145 "../src/minefield.vala"
							_tmp7__length2 = self->locations_length2;
#line 145 "../src/minefield.vala"
							_tmp8_ = x;
#line 145 "../src/minefield.vala"
							_tmp9_ = y;
#line 145 "../src/minefield.vala"
							_tmp10_ = location_new ();
#line 145 "../src/minefield.vala"
							_g_object_unref0 (_tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_]);
#line 145 "../src/minefield.vala"
							_tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_] = _tmp10_;
#line 145 "../src/minefield.vala"
							_tmp11_ = _tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_];
#line 472 "minefield.c"
						}
					}
				}
			}
		}
	}
#line 146 "../src/minefield.vala"
	self->width = width;
#line 147 "../src/minefield.vala"
	self->height = height;
#line 148 "../src/minefield.vala"
	self->n_mines = n_mines;
#line 140 "../src/minefield.vala"
	return self;
#line 487 "minefield.c"
}


Minefield*
minefield_new (guint width,
               guint height,
               guint n_mines)
{
#line 140 "../src/minefield.vala"
	return minefield_construct (TYPE_MINEFIELD, width, height, n_mines);
#line 498 "minefield.c"
}


gboolean
minefield_is_clock_started (Minefield* self)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 151 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 153 "../src/minefield.vala"
	_tmp0_ = minefield_get_elapsed (self);
#line 153 "../src/minefield.vala"
	_tmp1_ = _tmp0_;
#line 153 "../src/minefield.vala"
	result = _tmp1_ > ((gdouble) 0);
#line 153 "../src/minefield.vala"
	return result;
#line 518 "minefield.c"
}


gboolean
minefield_has_mine (Minefield* self,
                    guint x,
                    guint y)
{
	gboolean result = FALSE;
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gboolean _tmp2_;
#line 156 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 158 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 158 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 158 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 158 "../src/minefield.vala"
	_tmp2_ = _tmp1_->has_mine;
#line 158 "../src/minefield.vala"
	result = _tmp2_;
#line 158 "../src/minefield.vala"
	return result;
#line 549 "minefield.c"
}


gboolean
minefield_is_cleared (Minefield* self,
                      guint x,
                      guint y)
{
	gboolean result = FALSE;
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gboolean _tmp2_;
#line 161 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 163 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 163 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 163 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 163 "../src/minefield.vala"
	_tmp2_ = _tmp1_->cleared;
#line 163 "../src/minefield.vala"
	result = _tmp2_;
#line 163 "../src/minefield.vala"
	return result;
#line 580 "minefield.c"
}


gboolean
minefield_is_location (Minefield* self,
                       gint x,
                       gint y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 166 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 168 "../src/minefield.vala"
	if (x >= 0) {
#line 168 "../src/minefield.vala"
		_tmp2_ = y >= 0;
#line 599 "minefield.c"
	} else {
#line 168 "../src/minefield.vala"
		_tmp2_ = FALSE;
#line 603 "minefield.c"
	}
#line 168 "../src/minefield.vala"
	if (_tmp2_) {
#line 607 "minefield.c"
		guint _tmp3_;
#line 168 "../src/minefield.vala"
		_tmp3_ = self->width;
#line 168 "../src/minefield.vala"
		_tmp1_ = ((guint) x) < _tmp3_;
#line 613 "minefield.c"
	} else {
#line 168 "../src/minefield.vala"
		_tmp1_ = FALSE;
#line 617 "minefield.c"
	}
#line 168 "../src/minefield.vala"
	if (_tmp1_) {
#line 621 "minefield.c"
		guint _tmp4_;
#line 168 "../src/minefield.vala"
		_tmp4_ = self->height;
#line 168 "../src/minefield.vala"
		_tmp0_ = ((guint) y) < _tmp4_;
#line 627 "minefield.c"
	} else {
#line 168 "../src/minefield.vala"
		_tmp0_ = FALSE;
#line 631 "minefield.c"
	}
#line 168 "../src/minefield.vala"
	result = _tmp0_;
#line 168 "../src/minefield.vala"
	return result;
#line 637 "minefield.c"
}


void
minefield_multi_release (Minefield* self,
                         guint x,
                         guint y)
{
	gboolean _tmp0_ = FALSE;
	guint n_mines = 0U;
	guint n_flags = 0U;
	guint n_unknown = 0U;
	gboolean do_clear = FALSE;
	guint _tmp13_;
	guint _tmp14_;
#line 171 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/minefield.vala"
	if (!minefield_is_cleared (self, x, y)) {
#line 173 "../src/minefield.vala"
		_tmp0_ = TRUE;
#line 659 "minefield.c"
	} else {
#line 173 "../src/minefield.vala"
		_tmp0_ = minefield_get_flag (self, x, y) == FLAG_TYPE_FLAG;
#line 663 "minefield.c"
	}
#line 173 "../src/minefield.vala"
	if (_tmp0_) {
#line 174 "../src/minefield.vala"
		return;
#line 669 "minefield.c"
	}
#line 177 "../src/minefield.vala"
	n_mines = minefield_get_n_adjacent_mines (self, x, y);
#line 178 "../src/minefield.vala"
	n_flags = (guint) 0;
#line 179 "../src/minefield.vala"
	n_unknown = (guint) 0;
#line 677 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 180 "../src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 180 "../src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 180 "../src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 689 "minefield.c"
			Neighbour neighbour = {0};
#line 180 "../src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 693 "minefield.c"
			{
				gint nx = 0;
				Neighbour _tmp1_;
				gint _tmp2_;
				gint ny = 0;
				Neighbour _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gint _tmp10_;
				gint _tmp11_;
#line 182 "../src/minefield.vala"
				_tmp1_ = neighbour;
#line 182 "../src/minefield.vala"
				_tmp2_ = _tmp1_.x;
#line 182 "../src/minefield.vala"
				nx = ((gint) x) + _tmp2_;
#line 183 "../src/minefield.vala"
				_tmp3_ = neighbour;
#line 183 "../src/minefield.vala"
				_tmp4_ = _tmp3_.y;
#line 183 "../src/minefield.vala"
				ny = ((gint) y) + _tmp4_;
#line 184 "../src/minefield.vala"
				_tmp5_ = nx;
#line 184 "../src/minefield.vala"
				_tmp6_ = ny;
#line 184 "../src/minefield.vala"
				if (!minefield_is_location (self, _tmp5_, _tmp6_)) {
#line 185 "../src/minefield.vala"
					continue;
#line 727 "minefield.c"
				}
#line 186 "../src/minefield.vala"
				_tmp7_ = nx;
#line 186 "../src/minefield.vala"
				_tmp8_ = ny;
#line 186 "../src/minefield.vala"
				if (minefield_get_flag (self, (guint) _tmp7_, (guint) _tmp8_) == FLAG_TYPE_FLAG) {
#line 735 "minefield.c"
					guint _tmp9_;
#line 187 "../src/minefield.vala"
					_tmp9_ = n_flags;
#line 187 "../src/minefield.vala"
					n_flags = _tmp9_ + 1;
#line 741 "minefield.c"
				}
#line 188 "../src/minefield.vala"
				_tmp10_ = nx;
#line 188 "../src/minefield.vala"
				_tmp11_ = ny;
#line 188 "../src/minefield.vala"
				if (!minefield_is_cleared (self, (guint) _tmp10_, (guint) _tmp11_)) {
#line 749 "minefield.c"
					guint _tmp12_;
#line 189 "../src/minefield.vala"
					_tmp12_ = n_unknown;
#line 189 "../src/minefield.vala"
					n_unknown = _tmp12_ + 1;
#line 755 "minefield.c"
				}
			}
		}
	}
#line 195 "../src/minefield.vala"
	do_clear = FALSE;
#line 196 "../src/minefield.vala"
	_tmp13_ = n_mines;
#line 196 "../src/minefield.vala"
	_tmp14_ = n_flags;
#line 196 "../src/minefield.vala"
	if (_tmp13_ == _tmp14_) {
#line 197 "../src/minefield.vala"
		do_clear = TRUE;
#line 770 "minefield.c"
	} else {
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 198 "../src/minefield.vala"
		_tmp16_ = minefield_get_use_autoflag (self);
#line 198 "../src/minefield.vala"
		_tmp17_ = _tmp16_;
#line 198 "../src/minefield.vala"
		if (_tmp17_) {
#line 781 "minefield.c"
			guint _tmp18_;
			guint _tmp19_;
#line 198 "../src/minefield.vala"
			_tmp18_ = n_unknown;
#line 198 "../src/minefield.vala"
			_tmp19_ = n_mines;
#line 198 "../src/minefield.vala"
			_tmp15_ = _tmp18_ == _tmp19_;
#line 790 "minefield.c"
		} else {
#line 198 "../src/minefield.vala"
			_tmp15_ = FALSE;
#line 794 "minefield.c"
		}
#line 198 "../src/minefield.vala"
		if (_tmp15_) {
#line 199 "../src/minefield.vala"
			do_clear = FALSE;
#line 800 "minefield.c"
		} else {
#line 201 "../src/minefield.vala"
			return;
#line 804 "minefield.c"
		}
	}
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 205 "../src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 205 "../src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 205 "../src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 818 "minefield.c"
			Neighbour neighbour = {0};
#line 205 "../src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 822 "minefield.c"
			{
				gint nx = 0;
				Neighbour _tmp20_;
				gint _tmp21_;
				gint ny = 0;
				Neighbour _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_;
#line 207 "../src/minefield.vala"
				_tmp20_ = neighbour;
#line 207 "../src/minefield.vala"
				_tmp21_ = _tmp20_.x;
#line 207 "../src/minefield.vala"
				nx = ((gint) x) + _tmp21_;
#line 208 "../src/minefield.vala"
				_tmp22_ = neighbour;
#line 208 "../src/minefield.vala"
				_tmp23_ = _tmp22_.y;
#line 208 "../src/minefield.vala"
				ny = ((gint) y) + _tmp23_;
#line 209 "../src/minefield.vala"
				_tmp24_ = nx;
#line 209 "../src/minefield.vala"
				_tmp25_ = ny;
#line 209 "../src/minefield.vala"
				if (!minefield_is_location (self, _tmp24_, _tmp25_)) {
#line 210 "../src/minefield.vala"
					continue;
#line 854 "minefield.c"
				}
#line 212 "../src/minefield.vala"
				_tmp27_ = do_clear;
#line 212 "../src/minefield.vala"
				if (_tmp27_) {
#line 860 "minefield.c"
					gint _tmp28_;
					gint _tmp29_;
#line 212 "../src/minefield.vala"
					_tmp28_ = nx;
#line 212 "../src/minefield.vala"
					_tmp29_ = ny;
#line 212 "../src/minefield.vala"
					_tmp26_ = minefield_get_flag (self, (guint) _tmp28_, (guint) _tmp29_) != FLAG_TYPE_FLAG;
#line 869 "minefield.c"
				} else {
#line 212 "../src/minefield.vala"
					_tmp26_ = FALSE;
#line 873 "minefield.c"
				}
#line 212 "../src/minefield.vala"
				if (_tmp26_) {
#line 877 "minefield.c"
					gint _tmp30_;
					gint _tmp31_;
#line 213 "../src/minefield.vala"
					_tmp30_ = nx;
#line 213 "../src/minefield.vala"
					_tmp31_ = ny;
#line 213 "../src/minefield.vala"
					minefield_clear_mine (self, (guint) _tmp30_, (guint) _tmp31_);
#line 886 "minefield.c"
				} else {
					gint _tmp32_;
					gint _tmp33_;
#line 215 "../src/minefield.vala"
					_tmp32_ = nx;
#line 215 "../src/minefield.vala"
					_tmp33_ = ny;
#line 215 "../src/minefield.vala"
					minefield_set_flag (self, (guint) _tmp32_, (guint) _tmp33_, FLAG_TYPE_FLAG);
#line 896 "minefield.c"
				}
			}
		}
	}
}


void
minefield_clear_mine (Minefield* self,
                      guint x,
                      guint y)
{
	gboolean _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp4_ = FALSE;
	Location** _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	Location* _tmp6_;
	gboolean _tmp7_;
	Location** _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	Location* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp15_;
	gboolean _tmp16_;
#line 219 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 222 "../src/minefield.vala"
	_tmp0_ = self->placed_mines;
#line 222 "../src/minefield.vala"
	if (!_tmp0_) {
#line 224 "../src/minefield.vala"
		minefield_place_mines (self, x, y);
#line 225 "../src/minefield.vala"
		self->placed_mines = TRUE;
#line 935 "minefield.c"
	}
#line 228 "../src/minefield.vala"
	_tmp2_ = self->exploded;
#line 228 "../src/minefield.vala"
	if (!_tmp2_) {
#line 941 "minefield.c"
		GTimer* _tmp3_;
#line 228 "../src/minefield.vala"
		_tmp3_ = self->priv->clock;
#line 228 "../src/minefield.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 947 "minefield.c"
	} else {
#line 228 "../src/minefield.vala"
		_tmp1_ = FALSE;
#line 951 "minefield.c"
	}
#line 228 "../src/minefield.vala"
	if (_tmp1_) {
#line 229 "../src/minefield.vala"
		minefield_start_clock (self);
#line 957 "minefield.c"
	}
#line 231 "../src/minefield.vala"
	_tmp5_ = self->locations;
#line 231 "../src/minefield.vala"
	_tmp5__length1 = self->locations_length1;
#line 231 "../src/minefield.vala"
	_tmp5__length2 = self->locations_length2;
#line 231 "../src/minefield.vala"
	_tmp6_ = _tmp5_[(x * _tmp5__length2) + y];
#line 231 "../src/minefield.vala"
	_tmp7_ = _tmp6_->cleared;
#line 231 "../src/minefield.vala"
	if (_tmp7_) {
#line 231 "../src/minefield.vala"
		_tmp4_ = TRUE;
#line 973 "minefield.c"
	} else {
		Location** _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Location* _tmp9_;
		FlagType _tmp10_;
#line 231 "../src/minefield.vala"
		_tmp8_ = self->locations;
#line 231 "../src/minefield.vala"
		_tmp8__length1 = self->locations_length1;
#line 231 "../src/minefield.vala"
		_tmp8__length2 = self->locations_length2;
#line 231 "../src/minefield.vala"
		_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
#line 231 "../src/minefield.vala"
		_tmp10_ = _tmp9_->flag;
#line 231 "../src/minefield.vala"
		_tmp4_ = _tmp10_ == FLAG_TYPE_FLAG;
#line 992 "minefield.c"
	}
#line 231 "../src/minefield.vala"
	if (_tmp4_) {
#line 232 "../src/minefield.vala"
		return;
#line 998 "minefield.c"
	}
#line 234 "../src/minefield.vala"
	minefield_clear_mines_recursive (self, x, y);
#line 237 "../src/minefield.vala"
	_tmp11_ = self->locations;
#line 237 "../src/minefield.vala"
	_tmp11__length1 = self->locations_length1;
#line 237 "../src/minefield.vala"
	_tmp11__length2 = self->locations_length2;
#line 237 "../src/minefield.vala"
	_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
#line 237 "../src/minefield.vala"
	_tmp13_ = _tmp12_->has_mine;
#line 237 "../src/minefield.vala"
	if (_tmp13_) {
#line 1014 "minefield.c"
		gboolean _tmp14_;
#line 239 "../src/minefield.vala"
		_tmp14_ = self->exploded;
#line 239 "../src/minefield.vala"
		if (!_tmp14_) {
#line 241 "../src/minefield.vala"
			self->exploded = TRUE;
#line 242 "../src/minefield.vala"
			minefield_stop_clock (self);
#line 243 "../src/minefield.vala"
			g_signal_emit (self, minefield_signals[MINEFIELD_EXPLODE_SIGNAL], 0);
#line 1026 "minefield.c"
		}
#line 245 "../src/minefield.vala"
		return;
#line 1030 "minefield.c"
	}
#line 249 "../src/minefield.vala"
	_tmp15_ = minefield_get_is_complete (self);
#line 249 "../src/minefield.vala"
	_tmp16_ = _tmp15_;
#line 249 "../src/minefield.vala"
	if (_tmp16_) {
#line 251 "../src/minefield.vala"
		minefield_stop_clock (self);
#line 1040 "minefield.c"
		{
			gint tx = 0;
#line 252 "../src/minefield.vala"
			tx = 0;
#line 1045 "minefield.c"
			{
				gboolean _tmp17_ = FALSE;
#line 252 "../src/minefield.vala"
				_tmp17_ = TRUE;
#line 252 "../src/minefield.vala"
				while (TRUE) {
#line 1052 "minefield.c"
					gint _tmp19_;
					guint _tmp20_;
#line 252 "../src/minefield.vala"
					if (!_tmp17_) {
#line 1057 "minefield.c"
						gint _tmp18_;
#line 252 "../src/minefield.vala"
						_tmp18_ = tx;
#line 252 "../src/minefield.vala"
						tx = _tmp18_ + 1;
#line 1063 "minefield.c"
					}
#line 252 "../src/minefield.vala"
					_tmp17_ = FALSE;
#line 252 "../src/minefield.vala"
					_tmp19_ = tx;
#line 252 "../src/minefield.vala"
					_tmp20_ = self->width;
#line 252 "../src/minefield.vala"
					if (!(((guint) _tmp19_) < _tmp20_)) {
#line 252 "../src/minefield.vala"
						break;
#line 1075 "minefield.c"
					}
					{
						gint ty = 0;
#line 253 "../src/minefield.vala"
						ty = 0;
#line 1081 "minefield.c"
						{
							gboolean _tmp21_ = FALSE;
#line 253 "../src/minefield.vala"
							_tmp21_ = TRUE;
#line 253 "../src/minefield.vala"
							while (TRUE) {
#line 1088 "minefield.c"
								gint _tmp23_;
								guint _tmp24_;
								gint _tmp25_;
								gint _tmp26_;
#line 253 "../src/minefield.vala"
								if (!_tmp21_) {
#line 1095 "minefield.c"
									gint _tmp22_;
#line 253 "../src/minefield.vala"
									_tmp22_ = ty;
#line 253 "../src/minefield.vala"
									ty = _tmp22_ + 1;
#line 1101 "minefield.c"
								}
#line 253 "../src/minefield.vala"
								_tmp21_ = FALSE;
#line 253 "../src/minefield.vala"
								_tmp23_ = ty;
#line 253 "../src/minefield.vala"
								_tmp24_ = self->height;
#line 253 "../src/minefield.vala"
								if (!(((guint) _tmp23_) < _tmp24_)) {
#line 253 "../src/minefield.vala"
									break;
#line 1113 "minefield.c"
								}
#line 254 "../src/minefield.vala"
								_tmp25_ = tx;
#line 254 "../src/minefield.vala"
								_tmp26_ = ty;
#line 254 "../src/minefield.vala"
								if (minefield_has_mine (self, (guint) _tmp25_, (guint) _tmp26_)) {
#line 1121 "minefield.c"
									gint _tmp27_;
									gint _tmp28_;
#line 255 "../src/minefield.vala"
									_tmp27_ = tx;
#line 255 "../src/minefield.vala"
									_tmp28_ = ty;
#line 255 "../src/minefield.vala"
									minefield_set_flag (self, (guint) _tmp27_, (guint) _tmp28_, FLAG_TYPE_FLAG);
#line 1130 "minefield.c"
								}
							}
						}
					}
				}
			}
		}
#line 256 "../src/minefield.vala"
		g_signal_emit (self, minefield_signals[MINEFIELD_CLEARED_SIGNAL], 0);
#line 1140 "minefield.c"
	}
}


static void
minefield_clear_mines_recursive (Minefield* self,
                                 guint x,
                                 guint y)
{
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gboolean _tmp2_;
	Location** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	Location* _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	Location** _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Location* _tmp8_;
	FlagType _tmp9_;
	Location** _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	Location* _tmp13_;
	gboolean _tmp14_ = FALSE;
	Location** _tmp15_;
	gint _tmp15__length1;
	gint _tmp15__length2;
	Location* _tmp16_;
	gboolean _tmp17_;
#line 260 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 263 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 263 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 263 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 263 "../src/minefield.vala"
	_tmp2_ = _tmp1_->cleared;
#line 263 "../src/minefield.vala"
	if (_tmp2_) {
#line 264 "../src/minefield.vala"
		return;
#line 1192 "minefield.c"
	}
#line 266 "../src/minefield.vala"
	_tmp3_ = self->locations;
#line 266 "../src/minefield.vala"
	_tmp3__length1 = self->locations_length1;
#line 266 "../src/minefield.vala"
	_tmp3__length2 = self->locations_length2;
#line 266 "../src/minefield.vala"
	_tmp4_ = _tmp3_[(x * _tmp3__length2) + y];
#line 266 "../src/minefield.vala"
	_tmp4_->cleared = TRUE;
#line 267 "../src/minefield.vala"
	_tmp5_ = minefield_get_n_cleared (self);
#line 267 "../src/minefield.vala"
	_tmp6_ = _tmp5_;
#line 267 "../src/minefield.vala"
	minefield_set_n_cleared (self, _tmp6_ + 1);
#line 268 "../src/minefield.vala"
	_tmp7_ = self->locations;
#line 268 "../src/minefield.vala"
	_tmp7__length1 = self->locations_length1;
#line 268 "../src/minefield.vala"
	_tmp7__length2 = self->locations_length2;
#line 268 "../src/minefield.vala"
	_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
#line 268 "../src/minefield.vala"
	_tmp9_ = _tmp8_->flag;
#line 268 "../src/minefield.vala"
	if (_tmp9_ == FLAG_TYPE_FLAG) {
#line 1222 "minefield.c"
		guint _tmp10_;
		guint _tmp11_;
#line 269 "../src/minefield.vala"
		_tmp10_ = minefield_get_n_flags (self);
#line 269 "../src/minefield.vala"
		_tmp11_ = _tmp10_;
#line 269 "../src/minefield.vala"
		minefield_set_n_flags (self, _tmp11_ - 1);
#line 1231 "minefield.c"
	}
#line 270 "../src/minefield.vala"
	_tmp12_ = self->locations;
#line 270 "../src/minefield.vala"
	_tmp12__length1 = self->locations_length1;
#line 270 "../src/minefield.vala"
	_tmp12__length2 = self->locations_length2;
#line 270 "../src/minefield.vala"
	_tmp13_ = _tmp12_[(x * _tmp12__length2) + y];
#line 270 "../src/minefield.vala"
	_tmp13_->flag = FLAG_TYPE_NONE;
#line 271 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_REDRAW_SECTOR_SIGNAL], 0, x, y);
#line 272 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_MARKS_CHANGED_SIGNAL], 0);
#line 275 "../src/minefield.vala"
	_tmp15_ = self->locations;
#line 275 "../src/minefield.vala"
	_tmp15__length1 = self->locations_length1;
#line 275 "../src/minefield.vala"
	_tmp15__length2 = self->locations_length2;
#line 275 "../src/minefield.vala"
	_tmp16_ = _tmp15_[(x * _tmp15__length2) + y];
#line 275 "../src/minefield.vala"
	_tmp17_ = _tmp16_->has_mine;
#line 275 "../src/minefield.vala"
	if (!_tmp17_) {
#line 275 "../src/minefield.vala"
		_tmp14_ = minefield_get_n_adjacent_mines (self, x, y) == ((guint) 0);
#line 1261 "minefield.c"
	} else {
#line 275 "../src/minefield.vala"
		_tmp14_ = FALSE;
#line 1265 "minefield.c"
	}
#line 275 "../src/minefield.vala"
	if (_tmp14_) {
#line 1269 "minefield.c"
		{
			Neighbour* neighbour_collection = NULL;
			gint neighbour_collection_length1 = 0;
			gint _neighbour_collection_size_ = 0;
			gint neighbour_it = 0;
#line 277 "../src/minefield.vala"
			neighbour_collection = neighbour_map;
#line 277 "../src/minefield.vala"
			neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 277 "../src/minefield.vala"
			for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1281 "minefield.c"
				Neighbour neighbour = {0};
#line 277 "../src/minefield.vala"
				neighbour = neighbour_collection[neighbour_it];
#line 1285 "minefield.c"
				{
					gint nx = 0;
					Neighbour _tmp18_;
					gint _tmp19_;
					gint ny = 0;
					Neighbour _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
#line 279 "../src/minefield.vala"
					_tmp18_ = neighbour;
#line 279 "../src/minefield.vala"
					_tmp19_ = _tmp18_.x;
#line 279 "../src/minefield.vala"
					nx = ((gint) x) + _tmp19_;
#line 280 "../src/minefield.vala"
					_tmp20_ = neighbour;
#line 280 "../src/minefield.vala"
					_tmp21_ = _tmp20_.y;
#line 280 "../src/minefield.vala"
					ny = ((gint) y) + _tmp21_;
#line 281 "../src/minefield.vala"
					_tmp22_ = nx;
#line 281 "../src/minefield.vala"
					_tmp23_ = ny;
#line 281 "../src/minefield.vala"
					if (minefield_is_location (self, _tmp22_, _tmp23_)) {
#line 1313 "minefield.c"
						gint _tmp24_;
						gint _tmp25_;
#line 282 "../src/minefield.vala"
						_tmp24_ = nx;
#line 282 "../src/minefield.vala"
						_tmp25_ = ny;
#line 282 "../src/minefield.vala"
						minefield_clear_mines_recursive (self, (guint) _tmp24_, (guint) _tmp25_);
#line 1322 "minefield.c"
					}
				}
			}
		}
	}
}


void
minefield_set_flag (Minefield* self,
                    guint x,
                    guint y,
                    FlagType flag)
{
	gboolean _tmp0_ = FALSE;
	Location** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Location* _tmp2_;
	gboolean _tmp3_;
	Location** _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	Location* _tmp15_;
#line 287 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/minefield.vala"
	_tmp1_ = self->locations;
#line 289 "../src/minefield.vala"
	_tmp1__length1 = self->locations_length1;
#line 289 "../src/minefield.vala"
	_tmp1__length2 = self->locations_length2;
#line 289 "../src/minefield.vala"
	_tmp2_ = _tmp1_[(x * _tmp1__length2) + y];
#line 289 "../src/minefield.vala"
	_tmp3_ = _tmp2_->cleared;
#line 289 "../src/minefield.vala"
	if (_tmp3_) {
#line 289 "../src/minefield.vala"
		_tmp0_ = TRUE;
#line 1363 "minefield.c"
	} else {
		Location** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		Location* _tmp5_;
		FlagType _tmp6_;
#line 289 "../src/minefield.vala"
		_tmp4_ = self->locations;
#line 289 "../src/minefield.vala"
		_tmp4__length1 = self->locations_length1;
#line 289 "../src/minefield.vala"
		_tmp4__length2 = self->locations_length2;
#line 289 "../src/minefield.vala"
		_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 289 "../src/minefield.vala"
		_tmp6_ = _tmp5_->flag;
#line 289 "../src/minefield.vala"
		_tmp0_ = _tmp6_ == flag;
#line 1382 "minefield.c"
	}
#line 289 "../src/minefield.vala"
	if (_tmp0_) {
#line 290 "../src/minefield.vala"
		return;
#line 1388 "minefield.c"
	}
#line 292 "../src/minefield.vala"
	if (flag == FLAG_TYPE_FLAG) {
#line 1392 "minefield.c"
		guint _tmp7_;
		guint _tmp8_;
#line 293 "../src/minefield.vala"
		_tmp7_ = minefield_get_n_flags (self);
#line 293 "../src/minefield.vala"
		_tmp8_ = _tmp7_;
#line 293 "../src/minefield.vala"
		minefield_set_n_flags (self, _tmp8_ + 1);
#line 1401 "minefield.c"
	} else {
		Location** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		Location* _tmp10_;
		FlagType _tmp11_;
#line 294 "../src/minefield.vala"
		_tmp9_ = self->locations;
#line 294 "../src/minefield.vala"
		_tmp9__length1 = self->locations_length1;
#line 294 "../src/minefield.vala"
		_tmp9__length2 = self->locations_length2;
#line 294 "../src/minefield.vala"
		_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
#line 294 "../src/minefield.vala"
		_tmp11_ = _tmp10_->flag;
#line 294 "../src/minefield.vala"
		if (_tmp11_ == FLAG_TYPE_FLAG) {
#line 1420 "minefield.c"
			guint _tmp12_;
			guint _tmp13_;
#line 295 "../src/minefield.vala"
			_tmp12_ = minefield_get_n_flags (self);
#line 295 "../src/minefield.vala"
			_tmp13_ = _tmp12_;
#line 295 "../src/minefield.vala"
			minefield_set_n_flags (self, _tmp13_ - 1);
#line 1429 "minefield.c"
		}
	}
#line 297 "../src/minefield.vala"
	_tmp14_ = self->locations;
#line 297 "../src/minefield.vala"
	_tmp14__length1 = self->locations_length1;
#line 297 "../src/minefield.vala"
	_tmp14__length2 = self->locations_length2;
#line 297 "../src/minefield.vala"
	_tmp15_ = _tmp14_[(x * _tmp14__length2) + y];
#line 297 "../src/minefield.vala"
	_tmp15_->flag = flag;
#line 298 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_REDRAW_SECTOR_SIGNAL], 0, x, y);
#line 299 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_MARKS_CHANGED_SIGNAL], 0);
#line 1446 "minefield.c"
}


FlagType
minefield_get_flag (Minefield* self,
                    guint x,
                    guint y)
{
	FlagType result = 0;
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	FlagType _tmp2_;
#line 303 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 305 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 305 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 305 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 305 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 305 "../src/minefield.vala"
	_tmp2_ = _tmp1_->flag;
#line 305 "../src/minefield.vala"
	result = _tmp2_;
#line 305 "../src/minefield.vala"
	return result;
#line 1477 "minefield.c"
}


guint
minefield_get_n_adjacent_mines (Minefield* self,
                                guint x,
                                guint y)
{
	guint result = 0U;
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gint _tmp2_;
#line 308 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 310 "../src/minefield.vala"
	_tmp0_ = self->locations;
#line 310 "../src/minefield.vala"
	_tmp0__length1 = self->locations_length1;
#line 310 "../src/minefield.vala"
	_tmp0__length2 = self->locations_length2;
#line 310 "../src/minefield.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 310 "../src/minefield.vala"
	_tmp2_ = _tmp1_->adjacent_mines;
#line 310 "../src/minefield.vala"
	result = (guint) _tmp2_;
#line 310 "../src/minefield.vala"
	return result;
#line 1508 "minefield.c"
}


gboolean
minefield_has_flag_warning (Minefield* self,
                            guint x,
                            guint y)
{
	gboolean result = FALSE;
	guint n_mines = 0U;
	guint n_flags = 0U;
	guint _tmp12_;
	guint _tmp13_;
#line 313 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 315 "../src/minefield.vala"
	if (!minefield_is_cleared (self, x, y)) {
#line 316 "../src/minefield.vala"
		result = FALSE;
#line 316 "../src/minefield.vala"
		return result;
#line 1530 "minefield.c"
	}
#line 318 "../src/minefield.vala"
	n_mines = (guint) 0;
#line 318 "../src/minefield.vala"
	n_flags = (guint) 0;
#line 1536 "minefield.c"
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
#line 319 "../src/minefield.vala"
		neighbour_collection = neighbour_map;
#line 319 "../src/minefield.vala"
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 319 "../src/minefield.vala"
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1548 "minefield.c"
			Neighbour neighbour = {0};
#line 319 "../src/minefield.vala"
			neighbour = neighbour_collection[neighbour_it];
#line 1552 "minefield.c"
			{
				gint nx = 0;
				Neighbour _tmp0_;
				gint _tmp1_;
				gint ny = 0;
				Neighbour _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp9_;
				gint _tmp10_;
#line 321 "../src/minefield.vala"
				_tmp0_ = neighbour;
#line 321 "../src/minefield.vala"
				_tmp1_ = _tmp0_.x;
#line 321 "../src/minefield.vala"
				nx = ((gint) x) + _tmp1_;
#line 322 "../src/minefield.vala"
				_tmp2_ = neighbour;
#line 322 "../src/minefield.vala"
				_tmp3_ = _tmp2_.y;
#line 322 "../src/minefield.vala"
				ny = ((gint) y) + _tmp3_;
#line 323 "../src/minefield.vala"
				_tmp4_ = nx;
#line 323 "../src/minefield.vala"
				_tmp5_ = ny;
#line 323 "../src/minefield.vala"
				if (!minefield_is_location (self, _tmp4_, _tmp5_)) {
#line 324 "../src/minefield.vala"
					continue;
#line 1586 "minefield.c"
				}
#line 325 "../src/minefield.vala"
				_tmp6_ = nx;
#line 325 "../src/minefield.vala"
				_tmp7_ = ny;
#line 325 "../src/minefield.vala"
				if (minefield_has_mine (self, (guint) _tmp6_, (guint) _tmp7_)) {
#line 1594 "minefield.c"
					guint _tmp8_;
#line 326 "../src/minefield.vala"
					_tmp8_ = n_mines;
#line 326 "../src/minefield.vala"
					n_mines = _tmp8_ + 1;
#line 1600 "minefield.c"
				}
#line 327 "../src/minefield.vala"
				_tmp9_ = nx;
#line 327 "../src/minefield.vala"
				_tmp10_ = ny;
#line 327 "../src/minefield.vala"
				if (minefield_get_flag (self, (guint) _tmp9_, (guint) _tmp10_) == FLAG_TYPE_FLAG) {
#line 1608 "minefield.c"
					guint _tmp11_;
#line 328 "../src/minefield.vala"
					_tmp11_ = n_flags;
#line 328 "../src/minefield.vala"
					n_flags = _tmp11_ + 1;
#line 1614 "minefield.c"
				}
			}
		}
	}
#line 331 "../src/minefield.vala"
	_tmp12_ = n_flags;
#line 331 "../src/minefield.vala"
	_tmp13_ = n_mines;
#line 331 "../src/minefield.vala"
	result = _tmp12_ > _tmp13_;
#line 331 "../src/minefield.vala"
	return result;
#line 1627 "minefield.c"
}


static void
minefield_place_mines (Minefield* self,
                       guint x,
                       guint y)
{
#line 335 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 1638 "minefield.c"
	{
		gint n = 0;
#line 337 "../src/minefield.vala"
		n = 0;
#line 1643 "minefield.c"
		{
			gboolean _tmp0_ = FALSE;
#line 337 "../src/minefield.vala"
			_tmp0_ = TRUE;
#line 337 "../src/minefield.vala"
			while (TRUE) {
#line 1650 "minefield.c"
				gint _tmp1_;
				guint _tmp2_;
				gint32 rx = 0;
				guint _tmp3_;
				gint32 ry = 0;
				guint _tmp4_;
				gboolean _tmp5_ = FALSE;
				gint32 _tmp6_;
				Location** _tmp8_;
				gint _tmp8__length1;
				gint _tmp8__length2;
				gint32 _tmp9_;
				gint32 _tmp10_;
				Location* _tmp11_;
				gboolean _tmp12_;
#line 337 "../src/minefield.vala"
				if (!_tmp0_) {
#line 1668 "minefield.c"
				}
#line 337 "../src/minefield.vala"
				_tmp0_ = FALSE;
#line 337 "../src/minefield.vala"
				_tmp1_ = n;
#line 337 "../src/minefield.vala"
				_tmp2_ = self->n_mines;
#line 337 "../src/minefield.vala"
				if (!(((guint) _tmp1_) < _tmp2_)) {
#line 337 "../src/minefield.vala"
					break;
#line 1680 "minefield.c"
				}
#line 339 "../src/minefield.vala"
				_tmp3_ = self->width;
#line 339 "../src/minefield.vala"
				rx = g_random_int_range ((gint32) 0, (gint32) _tmp3_);
#line 340 "../src/minefield.vala"
				_tmp4_ = self->height;
#line 340 "../src/minefield.vala"
				ry = g_random_int_range ((gint32) 0, (gint32) _tmp4_);
#line 342 "../src/minefield.vala"
				_tmp6_ = rx;
#line 342 "../src/minefield.vala"
				if (((guint) _tmp6_) == x) {
#line 1694 "minefield.c"
					gint32 _tmp7_;
#line 342 "../src/minefield.vala"
					_tmp7_ = ry;
#line 342 "../src/minefield.vala"
					_tmp5_ = ((guint) _tmp7_) == y;
#line 1700 "minefield.c"
				} else {
#line 342 "../src/minefield.vala"
					_tmp5_ = FALSE;
#line 1704 "minefield.c"
				}
#line 342 "../src/minefield.vala"
				if (_tmp5_) {
#line 343 "../src/minefield.vala"
					continue;
#line 1710 "minefield.c"
				}
#line 345 "../src/minefield.vala"
				_tmp8_ = self->locations;
#line 345 "../src/minefield.vala"
				_tmp8__length1 = self->locations_length1;
#line 345 "../src/minefield.vala"
				_tmp8__length2 = self->locations_length2;
#line 345 "../src/minefield.vala"
				_tmp9_ = rx;
#line 345 "../src/minefield.vala"
				_tmp10_ = ry;
#line 345 "../src/minefield.vala"
				_tmp11_ = _tmp8_[(_tmp9_ * _tmp8__length2) + _tmp10_];
#line 345 "../src/minefield.vala"
				_tmp12_ = _tmp11_->has_mine;
#line 345 "../src/minefield.vala"
				if (!_tmp12_) {
#line 1728 "minefield.c"
					gboolean adj_found = FALSE;
					gboolean _tmp20_;
#line 347 "../src/minefield.vala"
					adj_found = FALSE;
#line 1733 "minefield.c"
					{
						Neighbour* neighbour_collection = NULL;
						gint neighbour_collection_length1 = 0;
						gint _neighbour_collection_size_ = 0;
						gint neighbour_it = 0;
#line 349 "../src/minefield.vala"
						neighbour_collection = neighbour_map;
#line 349 "../src/minefield.vala"
						neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 349 "../src/minefield.vala"
						for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1745 "minefield.c"
							Neighbour neighbour = {0};
#line 349 "../src/minefield.vala"
							neighbour = neighbour_collection[neighbour_it];
#line 1749 "minefield.c"
							{
								gboolean _tmp13_ = FALSE;
								gint32 _tmp14_;
								Neighbour _tmp15_;
								gint _tmp16_;
#line 351 "../src/minefield.vala"
								_tmp14_ = rx;
#line 351 "../src/minefield.vala"
								_tmp15_ = neighbour;
#line 351 "../src/minefield.vala"
								_tmp16_ = _tmp15_.x;
#line 351 "../src/minefield.vala"
								if (((guint) _tmp14_) == (x + _tmp16_)) {
#line 1763 "minefield.c"
									gint32 _tmp17_;
									Neighbour _tmp18_;
									gint _tmp19_;
#line 351 "../src/minefield.vala"
									_tmp17_ = ry;
#line 351 "../src/minefield.vala"
									_tmp18_ = neighbour;
#line 351 "../src/minefield.vala"
									_tmp19_ = _tmp18_.y;
#line 351 "../src/minefield.vala"
									_tmp13_ = ((guint) _tmp17_) == (y + _tmp19_);
#line 1775 "minefield.c"
								} else {
#line 351 "../src/minefield.vala"
									_tmp13_ = FALSE;
#line 1779 "minefield.c"
								}
#line 351 "../src/minefield.vala"
								if (_tmp13_) {
#line 353 "../src/minefield.vala"
									adj_found = TRUE;
#line 354 "../src/minefield.vala"
									break;
#line 1787 "minefield.c"
								}
							}
						}
					}
#line 358 "../src/minefield.vala"
					_tmp20_ = adj_found;
#line 358 "../src/minefield.vala"
					if (!_tmp20_) {
#line 1796 "minefield.c"
						Location** _tmp21_;
						gint _tmp21__length1;
						gint _tmp21__length2;
						gint32 _tmp22_;
						gint32 _tmp23_;
						Location* _tmp24_;
						gint _tmp25_;
#line 360 "../src/minefield.vala"
						_tmp21_ = self->locations;
#line 360 "../src/minefield.vala"
						_tmp21__length1 = self->locations_length1;
#line 360 "../src/minefield.vala"
						_tmp21__length2 = self->locations_length2;
#line 360 "../src/minefield.vala"
						_tmp22_ = rx;
#line 360 "../src/minefield.vala"
						_tmp23_ = ry;
#line 360 "../src/minefield.vala"
						_tmp24_ = _tmp21_[(_tmp22_ * _tmp21__length2) + _tmp23_];
#line 360 "../src/minefield.vala"
						_tmp24_->has_mine = TRUE;
#line 361 "../src/minefield.vala"
						_tmp25_ = n;
#line 361 "../src/minefield.vala"
						n = _tmp25_ + 1;
#line 1822 "minefield.c"
						{
							Neighbour* neighbour_collection = NULL;
							gint neighbour_collection_length1 = 0;
							gint _neighbour_collection_size_ = 0;
							gint neighbour_it = 0;
#line 362 "../src/minefield.vala"
							neighbour_collection = neighbour_map;
#line 362 "../src/minefield.vala"
							neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
#line 362 "../src/minefield.vala"
							for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
#line 1834 "minefield.c"
								Neighbour neighbour = {0};
#line 362 "../src/minefield.vala"
								neighbour = neighbour_collection[neighbour_it];
#line 1838 "minefield.c"
								{
									gint32 nx = 0;
									gint32 _tmp26_;
									Neighbour _tmp27_;
									gint _tmp28_;
									gint32 ny = 0;
									gint32 _tmp29_;
									Neighbour _tmp30_;
									gint _tmp31_;
									gint32 _tmp32_;
									gint32 _tmp33_;
#line 364 "../src/minefield.vala"
									_tmp26_ = rx;
#line 364 "../src/minefield.vala"
									_tmp27_ = neighbour;
#line 364 "../src/minefield.vala"
									_tmp28_ = _tmp27_.x;
#line 364 "../src/minefield.vala"
									nx = _tmp26_ + _tmp28_;
#line 365 "../src/minefield.vala"
									_tmp29_ = ry;
#line 365 "../src/minefield.vala"
									_tmp30_ = neighbour;
#line 365 "../src/minefield.vala"
									_tmp31_ = _tmp30_.y;
#line 365 "../src/minefield.vala"
									ny = _tmp29_ + _tmp31_;
#line 366 "../src/minefield.vala"
									_tmp32_ = nx;
#line 366 "../src/minefield.vala"
									_tmp33_ = ny;
#line 366 "../src/minefield.vala"
									if (minefield_is_location (self, (gint) _tmp32_, (gint) _tmp33_)) {
#line 1872 "minefield.c"
										Location** _tmp34_;
										gint _tmp34__length1;
										gint _tmp34__length2;
										gint32 _tmp35_;
										gint32 _tmp36_;
										Location* _tmp37_;
										gint _tmp38_;
#line 367 "../src/minefield.vala"
										_tmp34_ = self->locations;
#line 367 "../src/minefield.vala"
										_tmp34__length1 = self->locations_length1;
#line 367 "../src/minefield.vala"
										_tmp34__length2 = self->locations_length2;
#line 367 "../src/minefield.vala"
										_tmp35_ = nx;
#line 367 "../src/minefield.vala"
										_tmp36_ = ny;
#line 367 "../src/minefield.vala"
										_tmp37_ = _tmp34_[(_tmp35_ * _tmp34__length2) + _tmp36_];
#line 367 "../src/minefield.vala"
										_tmp38_ = _tmp37_->adjacent_mines;
#line 367 "../src/minefield.vala"
										_tmp37_->adjacent_mines = _tmp38_ + 1;
#line 1896 "minefield.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
}


static gboolean
_minefield_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = minefield_timeout_cb ((Minefield*) self);
#line 379 "../src/minefield.vala"
	return result;
#line 1916 "minefield.c"
}


static void
minefield_start_timer (Minefield* self)
{
	guint _tmp0_;
#line 374 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 376 "../src/minefield.vala"
	_tmp0_ = self->priv->clock_timeout;
#line 376 "../src/minefield.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 1930 "minefield.c"
		guint _tmp1_;
#line 377 "../src/minefield.vala"
		_tmp1_ = self->priv->clock_timeout;
#line 377 "../src/minefield.vala"
		g_source_remove (_tmp1_);
#line 1936 "minefield.c"
	}
#line 378 "../src/minefield.vala"
	self->priv->clock_timeout = (guint) 0;
#line 379 "../src/minefield.vala"
	self->priv->clock_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _minefield_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1942 "minefield.c"
}


static void
minefield_start_clock (Minefield* self)
{
	GTimer* _tmp0_;
#line 382 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 384 "../src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 384 "../src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 1956 "minefield.c"
		GTimer* _tmp1_;
#line 385 "../src/minefield.vala"
		_tmp1_ = g_timer_new ();
#line 385 "../src/minefield.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 385 "../src/minefield.vala"
		self->priv->clock = _tmp1_;
#line 1964 "minefield.c"
	}
#line 386 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_CLOCK_STARTED_SIGNAL], 0);
#line 387 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
#line 388 "../src/minefield.vala"
	minefield_start_timer (self);
#line 1972 "minefield.c"
}


static void
minefield_stop_clock (Minefield* self)
{
	GTimer* _tmp0_;
	gdouble _tmp1_;
	GTimer* _tmp2_;
	gdouble _tmp3_;
	guint _tmp4_;
	GTimer* _tmp6_;
#line 391 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 393 "../src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 393 "../src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 394 "../src/minefield.vala"
		return;
#line 1993 "minefield.c"
	}
#line 395 "../src/minefield.vala"
	_tmp1_ = self->priv->clock_elapsed;
#line 395 "../src/minefield.vala"
	_tmp2_ = self->priv->clock;
#line 395 "../src/minefield.vala"
	_tmp3_ = g_timer_elapsed (_tmp2_, NULL);
#line 395 "../src/minefield.vala"
	self->priv->clock_elapsed = _tmp1_ + _tmp3_;
#line 396 "../src/minefield.vala"
	_tmp4_ = self->priv->clock_timeout;
#line 396 "../src/minefield.vala"
	if (_tmp4_ != ((guint) 0)) {
#line 2007 "minefield.c"
		guint _tmp5_;
#line 397 "../src/minefield.vala"
		_tmp5_ = self->priv->clock_timeout;
#line 397 "../src/minefield.vala"
		g_source_remove (_tmp5_);
#line 2013 "minefield.c"
	}
#line 398 "../src/minefield.vala"
	self->priv->clock_timeout = (guint) 0;
#line 399 "../src/minefield.vala"
	_tmp6_ = self->priv->clock;
#line 399 "../src/minefield.vala"
	g_timer_stop (_tmp6_);
#line 400 "../src/minefield.vala"
	_g_timer_destroy0 (self->priv->clock);
#line 400 "../src/minefield.vala"
	self->priv->clock = NULL;
#line 401 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
#line 2027 "minefield.c"
}


static void
minefield_continue_clock (Minefield* self)
{
	GTimer* _tmp0_;
#line 404 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 406 "../src/minefield.vala"
	_tmp0_ = self->priv->clock;
#line 406 "../src/minefield.vala"
	if (_tmp0_ == NULL) {
#line 2041 "minefield.c"
		GTimer* _tmp1_;
#line 407 "../src/minefield.vala"
		_tmp1_ = g_timer_new ();
#line 407 "../src/minefield.vala"
		_g_timer_destroy0 (self->priv->clock);
#line 407 "../src/minefield.vala"
		self->priv->clock = _tmp1_;
#line 2049 "minefield.c"
	} else {
		GTimer* _tmp2_;
#line 409 "../src/minefield.vala"
		_tmp2_ = self->priv->clock;
#line 409 "../src/minefield.vala"
		g_timer_continue (_tmp2_);
#line 2056 "minefield.c"
	}
#line 410 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
#line 411 "../src/minefield.vala"
	minefield_start_timer (self);
#line 2062 "minefield.c"
}


static gboolean
minefield_timeout_cb (Minefield* self)
{
	gboolean result = FALSE;
#line 414 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 416 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
#line 417 "../src/minefield.vala"
	result = TRUE;
#line 417 "../src/minefield.vala"
	return result;
#line 2078 "minefield.c"
}


guint
minefield_get_n_cleared (Minefield* self)
{
	guint result;
	guint _tmp0_;
#line 77 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 77 "../src/minefield.vala"
	_tmp0_ = self->priv->_n_cleared;
#line 77 "../src/minefield.vala"
	result = _tmp0_;
#line 77 "../src/minefield.vala"
	return result;
#line 2095 "minefield.c"
}


void
minefield_set_n_cleared (Minefield* self,
                         guint value)
{
#line 78 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/minefield.vala"
	self->priv->_n_cleared = value;
#line 78 "../src/minefield.vala"
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_N_CLEARED_PROPERTY]);
#line 2109 "minefield.c"
}


gboolean
minefield_get_is_complete (Minefield* self)
{
	gboolean result;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
#line 83 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../src/minefield.vala"
	_tmp0_ = minefield_get_n_cleared (self);
#line 83 "../src/minefield.vala"
	_tmp1_ = _tmp0_;
#line 83 "../src/minefield.vala"
	_tmp2_ = self->width;
#line 83 "../src/minefield.vala"
	_tmp3_ = self->height;
#line 83 "../src/minefield.vala"
	_tmp4_ = self->n_mines;
#line 83 "../src/minefield.vala"
	result = _tmp1_ == ((_tmp2_ * _tmp3_) - _tmp4_);
#line 83 "../src/minefield.vala"
	return result;
#line 2138 "minefield.c"
}


guint
minefield_get_n_flags (Minefield* self)
{
	guint result;
	guint _tmp0_;
#line 88 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 88 "../src/minefield.vala"
	_tmp0_ = self->priv->_n_flags;
#line 88 "../src/minefield.vala"
	result = _tmp0_;
#line 88 "../src/minefield.vala"
	return result;
#line 2155 "minefield.c"
}


void
minefield_set_n_flags (Minefield* self,
                       guint value)
{
#line 89 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/minefield.vala"
	self->priv->_n_flags = value;
#line 89 "../src/minefield.vala"
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_N_FLAGS_PROPERTY]);
#line 2169 "minefield.c"
}


gboolean
minefield_get_use_autoflag (Minefield* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 94 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 94 "../src/minefield.vala"
	_tmp0_ = self->_use_autoflag;
#line 94 "../src/minefield.vala"
	result = _tmp0_;
#line 94 "../src/minefield.vala"
	return result;
#line 2186 "minefield.c"
}


void
minefield_set_use_autoflag (Minefield* self,
                            gboolean value)
{
#line 95 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/minefield.vala"
	self->_use_autoflag = value;
#line 95 "../src/minefield.vala"
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_USE_AUTOFLAG_PROPERTY]);
#line 2200 "minefield.c"
}


gdouble
minefield_get_elapsed (Minefield* self)
{
	gdouble result;
	gdouble _tmp0_ = 0.0;
	GTimer* _tmp1_;
	gdouble _tmp4_;
#line 105 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 107 "../src/minefield.vala"
	_tmp1_ = self->priv->clock;
#line 107 "../src/minefield.vala"
	if (_tmp1_ == NULL) {
#line 107 "../src/minefield.vala"
		_tmp0_ = 0.0;
#line 2219 "minefield.c"
	} else {
		GTimer* _tmp2_;
		gdouble _tmp3_;
#line 107 "../src/minefield.vala"
		_tmp2_ = self->priv->clock;
#line 107 "../src/minefield.vala"
		_tmp3_ = g_timer_elapsed (_tmp2_, NULL);
#line 107 "../src/minefield.vala"
		_tmp0_ = _tmp3_;
#line 2229 "minefield.c"
	}
#line 107 "../src/minefield.vala"
	_tmp4_ = self->priv->clock_elapsed;
#line 107 "../src/minefield.vala"
	result = _tmp4_ + _tmp0_;
#line 107 "../src/minefield.vala"
	return result;
#line 2237 "minefield.c"
}


gboolean
minefield_get_paused (Minefield* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 127 "../src/minefield.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 127 "../src/minefield.vala"
	_tmp0_ = self->priv->_paused;
#line 127 "../src/minefield.vala"
	result = _tmp0_;
#line 127 "../src/minefield.vala"
	return result;
#line 2254 "minefield.c"
}


void
minefield_set_paused (Minefield* self,
                      gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp4_ = FALSE;
#line 114 "../src/minefield.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/minefield.vala"
	_tmp1_ = minefield_get_is_complete (self);
#line 116 "../src/minefield.vala"
	_tmp2_ = _tmp1_;
#line 116 "../src/minefield.vala"
	if (_tmp2_) {
#line 116 "../src/minefield.vala"
		_tmp0_ = TRUE;
#line 2276 "minefield.c"
	} else {
		gboolean _tmp3_;
#line 116 "../src/minefield.vala"
		_tmp3_ = self->exploded;
#line 116 "../src/minefield.vala"
		_tmp0_ = _tmp3_;
#line 2283 "minefield.c"
	}
#line 116 "../src/minefield.vala"
	if (_tmp0_) {
#line 117 "../src/minefield.vala"
		return;
#line 2289 "minefield.c"
	}
#line 119 "../src/minefield.vala"
	if (value) {
#line 2293 "minefield.c"
		gboolean _tmp5_;
#line 119 "../src/minefield.vala"
		_tmp5_ = self->priv->_paused;
#line 119 "../src/minefield.vala"
		_tmp4_ = !_tmp5_;
#line 2299 "minefield.c"
	} else {
#line 119 "../src/minefield.vala"
		_tmp4_ = FALSE;
#line 2303 "minefield.c"
	}
#line 119 "../src/minefield.vala"
	if (_tmp4_) {
#line 120 "../src/minefield.vala"
		minefield_stop_clock (self);
#line 2309 "minefield.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 121 "../src/minefield.vala"
		if (!value) {
#line 2314 "minefield.c"
			gboolean _tmp7_;
#line 121 "../src/minefield.vala"
			_tmp7_ = self->priv->_paused;
#line 121 "../src/minefield.vala"
			_tmp6_ = _tmp7_;
#line 2320 "minefield.c"
		} else {
#line 121 "../src/minefield.vala"
			_tmp6_ = FALSE;
#line 2324 "minefield.c"
		}
#line 121 "../src/minefield.vala"
		if (_tmp6_) {
#line 122 "../src/minefield.vala"
			minefield_continue_clock (self);
#line 2330 "minefield.c"
		}
	}
#line 124 "../src/minefield.vala"
	self->priv->_paused = value;
#line 125 "../src/minefield.vala"
	g_signal_emit (self, minefield_signals[MINEFIELD_PAUSED_CHANGED_SIGNAL], 0);
#line 114 "../src/minefield.vala"
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_PAUSED_PROPERTY]);
#line 2339 "minefield.c"
}


static void
g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 51 "../src/minefield.vala"
	g_return_if_fail (n_param_values == 3);
#line 51 "../src/minefield.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 51 "../src/minefield.vala"
		data1 = closure->data;
#line 51 "../src/minefield.vala"
		data2 = param_values->data[0].v_pointer;
#line 2365 "minefield.c"
	} else {
#line 51 "../src/minefield.vala"
		data1 = param_values->data[0].v_pointer;
#line 51 "../src/minefield.vala"
		data2 = closure->data;
#line 2371 "minefield.c"
	}
#line 51 "../src/minefield.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 51 "../src/minefield.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 2377 "minefield.c"
}


static void
minefield_class_init (MinefieldClass * klass)
{
#line 51 "../src/minefield.vala"
	minefield_parent_class = g_type_class_peek_parent (klass);
#line 51 "../src/minefield.vala"
	g_type_class_adjust_private_offset (klass, &Minefield_private_offset);
#line 51 "../src/minefield.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_minefield_get_property;
#line 51 "../src/minefield.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_minefield_set_property;
#line 51 "../src/minefield.vala"
	G_OBJECT_CLASS (klass)->finalize = minefield_finalize;
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_N_CLEARED_PROPERTY, minefield_properties[MINEFIELD_N_CLEARED_PROPERTY] = g_param_spec_uint ("n-cleared", "n-cleared", "n-cleared", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_IS_COMPLETE_PROPERTY, minefield_properties[MINEFIELD_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_N_FLAGS_PROPERTY, minefield_properties[MINEFIELD_N_FLAGS_PROPERTY] = g_param_spec_uint ("n-flags", "n-flags", "n-flags", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_USE_AUTOFLAG_PROPERTY, minefield_properties[MINEFIELD_USE_AUTOFLAG_PROPERTY] = g_param_spec_boolean ("use-autoflag", "use-autoflag", "use-autoflag", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_ELAPSED_PROPERTY, minefield_properties[MINEFIELD_ELAPSED_PROPERTY] = g_param_spec_double ("elapsed", "elapsed", "elapsed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 51 "../src/minefield.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_PAUSED_PROPERTY, minefield_properties[MINEFIELD_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_CLOCK_STARTED_SIGNAL] = g_signal_new ("clock-started", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_TICK_SIGNAL] = g_signal_new ("tick", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_REDRAW_SECTOR_SIGNAL] = g_signal_new ("redraw-sector", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_MARKS_CHANGED_SIGNAL] = g_signal_new ("marks-changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_EXPLODE_SIGNAL] = g_signal_new ("explode", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 51 "../src/minefield.vala"
	minefield_signals[MINEFIELD_CLEARED_SIGNAL] = g_signal_new ("cleared", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2420 "minefield.c"
}


static void
minefield_instance_init (Minefield * self)
{
#line 51 "../src/minefield.vala"
	self->priv = minefield_get_instance_private (self);
#line 54 "../src/minefield.vala"
	self->width = (guint) 0;
#line 55 "../src/minefield.vala"
	self->height = (guint) 0;
#line 58 "../src/minefield.vala"
	self->n_mines = (guint) 0;
#line 64 "../src/minefield.vala"
	self->exploded = FALSE;
#line 67 "../src/minefield.vala"
	self->placed_mines = FALSE;
#line 70 "../src/minefield.vala"
	self->priv->_n_cleared = (guint) 0;
#line 71 "../src/minefield.vala"
	self->priv->_n_flags = (guint) 0;
#line 111 "../src/minefield.vala"
	self->priv->_paused = FALSE;
#line 2445 "minefield.c"
}


static void
minefield_finalize (GObject * obj)
{
	Minefield * self;
#line 51 "../src/minefield.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINEFIELD, Minefield);
#line 61 "../src/minefield.vala"
	self->locations = (_vala_array_free (self->locations, self->locations_length1 * self->locations_length2, (GDestroyNotify) g_object_unref), NULL);
#line 100 "../src/minefield.vala"
	_g_timer_destroy0 (self->priv->clock);
#line 51 "../src/minefield.vala"
	G_OBJECT_CLASS (minefield_parent_class)->finalize (obj);
#line 2461 "minefield.c"
}


GType
minefield_get_type (void)
{
	static volatile gsize minefield_type_id__volatile = 0;
	if (g_once_init_enter (&minefield_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MinefieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) minefield_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Minefield), 0, (GInstanceInitFunc) minefield_instance_init, NULL };
		GType minefield_type_id;
		minefield_type_id = g_type_register_static (G_TYPE_OBJECT, "Minefield", &g_define_type_info, 0);
		Minefield_private_offset = g_type_add_instance_private (minefield_type_id, sizeof (MinefieldPrivate));
		g_once_init_leave (&minefield_type_id__volatile, minefield_type_id);
	}
	return minefield_type_id__volatile;
}


static void
_vala_minefield_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Minefield * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINEFIELD, Minefield);
#line 51 "../src/minefield.vala"
	switch (property_id) {
#line 51 "../src/minefield.vala"
		case MINEFIELD_N_CLEARED_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_uint (value, minefield_get_n_cleared (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_IS_COMPLETE_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_boolean (value, minefield_get_is_complete (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_N_FLAGS_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_uint (value, minefield_get_n_flags (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_USE_AUTOFLAG_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_boolean (value, minefield_get_use_autoflag (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_ELAPSED_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_double (value, minefield_get_elapsed (self));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_PAUSED_PROPERTY:
#line 51 "../src/minefield.vala"
		g_value_set_boolean (value, minefield_get_paused (self));
#line 51 "../src/minefield.vala"
		break;
#line 2526 "minefield.c"
		default:
#line 51 "../src/minefield.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 51 "../src/minefield.vala"
		break;
#line 2532 "minefield.c"
	}
}


static void
_vala_minefield_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Minefield * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINEFIELD, Minefield);
#line 51 "../src/minefield.vala"
	switch (property_id) {
#line 51 "../src/minefield.vala"
		case MINEFIELD_N_CLEARED_PROPERTY:
#line 51 "../src/minefield.vala"
		minefield_set_n_cleared (self, g_value_get_uint (value));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_N_FLAGS_PROPERTY:
#line 51 "../src/minefield.vala"
		minefield_set_n_flags (self, g_value_get_uint (value));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_USE_AUTOFLAG_PROPERTY:
#line 51 "../src/minefield.vala"
		minefield_set_use_autoflag (self, g_value_get_boolean (value));
#line 51 "../src/minefield.vala"
		break;
#line 51 "../src/minefield.vala"
		case MINEFIELD_PAUSED_PROPERTY:
#line 51 "../src/minefield.vala"
		minefield_set_paused (self, g_value_get_boolean (value));
#line 51 "../src/minefield.vala"
		break;
#line 2571 "minefield.c"
		default:
#line 51 "../src/minefield.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 51 "../src/minefield.vala"
		break;
#line 2577 "minefield.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



